<?php

namespace Cursed\Screen\Component;

use Cursed\Screen\Screen;
use Cursed\Screen\Renderable;

class StatusBar implements Renderable
{
    public ?string $message = null;

    public array $hotkeys = [];

    public function render(Screen $screen, array $options = []): void
    {
        $width = $screen->columns;
        $output = [ "\e[0;37;40m" ];
        foreach ($this->hotkeys as $key=>$info) {
            $length = mb_strlen($key) + mb_strlen($info) + 3;
            if ($width > $length) {
                $output[] = sprintf(" \e[2m%s\e[22m \e[3m%s\e[23m ", $key, $info);
                $width -= $length;
            } else break;
        }
        $output[] = "\e[K\e[0m";
        $screen->writeAt(0, -1, join("", $output));
    }
}
